/* Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.activiti.designer.export.bpmn20.export;

import javax.xml.stream.XMLStreamWriter;

import org.eclipse.bpmn2.Activity;
import org.eclipse.emf.ecore.EObject;


/**
 * @author Tijs Rademakers
 */
public class AsyncActivityExport implements ActivitiNamespaceConstants {

  public static void createDefaultFlow(EObject object, XMLStreamWriter xtw) throws Exception {
    boolean async = false;
    if(object instanceof Activity) {
      Activity activity = (Activity) object;
      async = activity.isAsynchronous();
    }
    
    if(async == true) {
      xtw.writeAttribute(ACTIVITI_EXTENSIONS_PREFIX, ACTIVITI_EXTENSIONS_NAMESPACE, "async", "true");
    }
  }
}
