/**
 * <copyright>
 * 
 * Copyright (c) 2010 SAP AG.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    Reiner Hille-Doering (SAP AG) - initial API and implementation and/or initial documentation
 * 
 * </copyright>
 */
package org.eclipse.bpmn2.di.tests;

import junit.framework.TestCase;

import junit.textui.TestRunner;

import org.eclipse.bpmn2.di.BpmnDiFactory;
import org.eclipse.bpmn2.di.DocumentRoot;

/**
 * <!-- begin-user-doc -->
 * A test case for the model object '<em><b>Document Root</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are tested:
 * <ul>
 *   <li>{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNDiagram() <em>BPMN Diagram</em>}</li>
 *   <li>{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNEdge() <em>BPMN Edge</em>}</li>
 *   <li>{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNLabel() <em>BPMN Label</em>}</li>
 *   <li>{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNLabelStyle() <em>BPMN Label Style</em>}</li>
 *   <li>{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNPlane() <em>BPMN Plane</em>}</li>
 *   <li>{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNShape() <em>BPMN Shape</em>}</li>
 * </ul>
 * </p>
 * @generated
 */
public class DocumentRootTest extends TestCase {

	/**
	 * The fixture for this Document Root test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentRoot fixture = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static void main(String[] args) {
		TestRunner.run(DocumentRootTest.class);
	}

	/**
	 * Constructs a new Document Root test case with the given name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DocumentRootTest(String name) {
		super(name);
	}

	/**
	 * Sets the fixture for this Document Root test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void setFixture(DocumentRoot fixture) {
		this.fixture = fixture;
	}

	/**
	 * Returns the fixture for this Document Root test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentRoot getFixture() {
		return fixture;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see junit.framework.TestCase#setUp()
	 * @generated
	 */
	@Override
	protected void setUp() throws Exception {
		setFixture(BpmnDiFactory.eINSTANCE.createDocumentRoot());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see junit.framework.TestCase#tearDown()
	 * @generated
	 */
	@Override
	protected void tearDown() throws Exception {
		setFixture(null);
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNDiagram() <em>BPMN Diagram</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#getBPMNDiagram()
	 * @generated
	 */
	public void testGetBPMNDiagram() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#setBPMNDiagram(org.eclipse.bpmn2.di.BPMNDiagram) <em>BPMN Diagram</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#setBPMNDiagram(org.eclipse.bpmn2.di.BPMNDiagram)
	 * @generated
	 */
	public void testSetBPMNDiagram() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNEdge() <em>BPMN Edge</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#getBPMNEdge()
	 * @generated
	 */
	public void testGetBPMNEdge() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#setBPMNEdge(org.eclipse.bpmn2.di.BPMNEdge) <em>BPMN Edge</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#setBPMNEdge(org.eclipse.bpmn2.di.BPMNEdge)
	 * @generated
	 */
	public void testSetBPMNEdge() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNLabel() <em>BPMN Label</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#getBPMNLabel()
	 * @generated
	 */
	public void testGetBPMNLabel() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#setBPMNLabel(org.eclipse.bpmn2.di.BPMNLabel) <em>BPMN Label</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#setBPMNLabel(org.eclipse.bpmn2.di.BPMNLabel)
	 * @generated
	 */
	public void testSetBPMNLabel() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNLabelStyle() <em>BPMN Label Style</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#getBPMNLabelStyle()
	 * @generated
	 */
	public void testGetBPMNLabelStyle() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#setBPMNLabelStyle(org.eclipse.bpmn2.di.BPMNLabelStyle) <em>BPMN Label Style</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#setBPMNLabelStyle(org.eclipse.bpmn2.di.BPMNLabelStyle)
	 * @generated
	 */
	public void testSetBPMNLabelStyle() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNPlane() <em>BPMN Plane</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#getBPMNPlane()
	 * @generated
	 */
	public void testGetBPMNPlane() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#setBPMNPlane(org.eclipse.bpmn2.di.BPMNPlane) <em>BPMN Plane</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#setBPMNPlane(org.eclipse.bpmn2.di.BPMNPlane)
	 * @generated
	 */
	public void testSetBPMNPlane() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#getBPMNShape() <em>BPMN Shape</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#getBPMNShape()
	 * @generated
	 */
	public void testGetBPMNShape() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.bpmn2.di.DocumentRoot#setBPMNShape(org.eclipse.bpmn2.di.BPMNShape) <em>BPMN Shape</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.bpmn2.di.DocumentRoot#setBPMNShape(org.eclipse.bpmn2.di.BPMNShape)
	 * @generated
	 */
	public void testSetBPMNShape() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

} //DocumentRootTest
