/**
 * <copyright>
 * 
 * Copyright (c) 2010 SAP AG.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    Reiner Hille-Doering (SAP AG) - initial API and implementation and/or initial documentation
 * 
 * </copyright>
 */
package org.eclipse.dd.di.tests;

import junit.framework.TestCase;

import junit.textui.TestRunner;

import org.eclipse.dd.di.DiFactory;
import org.eclipse.dd.di.DocumentRoot;

/**
 * <!-- begin-user-doc -->
 * A test case for the model object '<em><b>Document Root</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are tested:
 * <ul>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getDiagramElement() <em>Diagram Element</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getDiagram() <em>Diagram</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getEdge() <em>Edge</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getLabel() <em>Label</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getLabeledEdge() <em>Labeled Edge</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getLabeledShape() <em>Labeled Shape</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getNode() <em>Node</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getPlane() <em>Plane</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getShape() <em>Shape</em>}</li>
 *   <li>{@link org.eclipse.dd.di.DocumentRoot#getStyle() <em>Style</em>}</li>
 * </ul>
 * </p>
 * @generated
 */
public class DocumentRootTest extends TestCase {

	/**
	 * The fixture for this Document Root test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentRoot fixture = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static void main(String[] args) {
		TestRunner.run(DocumentRootTest.class);
	}

	/**
	 * Constructs a new Document Root test case with the given name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DocumentRootTest(String name) {
		super(name);
	}

	/**
	 * Sets the fixture for this Document Root test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void setFixture(DocumentRoot fixture) {
		this.fixture = fixture;
	}

	/**
	 * Returns the fixture for this Document Root test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentRoot getFixture() {
		return fixture;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see junit.framework.TestCase#setUp()
	 * @generated
	 */
	@Override
	protected void setUp() throws Exception {
		setFixture(DiFactory.eINSTANCE.createDocumentRoot());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see junit.framework.TestCase#tearDown()
	 * @generated
	 */
	@Override
	protected void tearDown() throws Exception {
		setFixture(null);
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getDiagramElement() <em>Diagram Element</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getDiagramElement()
	 * @generated
	 */
	public void testGetDiagramElement() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setDiagramElement(org.eclipse.dd.di.DiagramElement) <em>Diagram Element</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setDiagramElement(org.eclipse.dd.di.DiagramElement)
	 * @generated
	 */
	public void testSetDiagramElement() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getDiagram() <em>Diagram</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getDiagram()
	 * @generated
	 */
	public void testGetDiagram() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setDiagram(org.eclipse.dd.di.Diagram) <em>Diagram</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setDiagram(org.eclipse.dd.di.Diagram)
	 * @generated
	 */
	public void testSetDiagram() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getEdge() <em>Edge</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getEdge()
	 * @generated
	 */
	public void testGetEdge() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setEdge(org.eclipse.dd.di.Edge) <em>Edge</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setEdge(org.eclipse.dd.di.Edge)
	 * @generated
	 */
	public void testSetEdge() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getLabel() <em>Label</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getLabel()
	 * @generated
	 */
	public void testGetLabel() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setLabel(org.eclipse.dd.di.Label) <em>Label</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setLabel(org.eclipse.dd.di.Label)
	 * @generated
	 */
	public void testSetLabel() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getLabeledEdge() <em>Labeled Edge</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getLabeledEdge()
	 * @generated
	 */
	public void testGetLabeledEdge() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setLabeledEdge(org.eclipse.dd.di.LabeledEdge) <em>Labeled Edge</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setLabeledEdge(org.eclipse.dd.di.LabeledEdge)
	 * @generated
	 */
	public void testSetLabeledEdge() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getLabeledShape() <em>Labeled Shape</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getLabeledShape()
	 * @generated
	 */
	public void testGetLabeledShape() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setLabeledShape(org.eclipse.dd.di.LabeledShape) <em>Labeled Shape</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setLabeledShape(org.eclipse.dd.di.LabeledShape)
	 * @generated
	 */
	public void testSetLabeledShape() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getNode() <em>Node</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getNode()
	 * @generated
	 */
	public void testGetNode() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setNode(org.eclipse.dd.di.Node) <em>Node</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setNode(org.eclipse.dd.di.Node)
	 * @generated
	 */
	public void testSetNode() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getPlane() <em>Plane</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getPlane()
	 * @generated
	 */
	public void testGetPlane() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setPlane(org.eclipse.dd.di.Plane) <em>Plane</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setPlane(org.eclipse.dd.di.Plane)
	 * @generated
	 */
	public void testSetPlane() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getShape() <em>Shape</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getShape()
	 * @generated
	 */
	public void testGetShape() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setShape(org.eclipse.dd.di.Shape) <em>Shape</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setShape(org.eclipse.dd.di.Shape)
	 * @generated
	 */
	public void testSetShape() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#getStyle() <em>Style</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#getStyle()
	 * @generated
	 */
	public void testGetStyle() {
		// TODO: implement this feature getter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link org.eclipse.dd.di.DocumentRoot#setStyle(org.eclipse.dd.di.Style) <em>Style</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.dd.di.DocumentRoot#setStyle(org.eclipse.dd.di.Style)
	 * @generated
	 */
	public void testSetStyle() {
		// TODO: implement this feature setter test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

} //DocumentRootTest
