/* Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.activiti.engine.impl;



/**
 * Represents a variable value used in a task query.
 * 
 * @author Frederik Heremans
 */
public class TaskQueryVariableValue extends QueryVariableValue {

  private static final long serialVersionUID = 1L;
  protected boolean taskVariable;
  
  public TaskQueryVariableValue(String name, Object value, QueryOperator operator, boolean isTaskVariable) {
    super(name, value, operator);
    this.taskVariable = isTaskVariable;
  }

  public boolean isTaskVariable() {
    return taskVariable;
  }
  
}
